library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity compito is
	port (clk,nw: in std_logic;
	din: in std_logic_vector(15 downto 0);
	op: in std_logic_vector(1 downto 0);
	ris: out std_logic_vector(15 downto 0);
	ready : out std_logic);
end compito;

architecture beh of compito is
type stati is (idle, lettura0, lettura1, esegui);
signal st: stati;
signal en_let0, en_let1, en_esegui: std_logic;
signal oper: std_logic_vector(1 downto 0);
signal d0,d1: std_logic_vector(15 downto 0);
signal conta : integer range 0 to 1;

begin
	process(clk)
	 begin
       if clk'event and clk='0' then
		   case st is
			   when idle => if nw='1' then st <= lettura0;
			   				else st <= idle;
			   				end if;
			   when lettura0 => if op(1) = '1' then st <= esegui;
			   					else st <= lettura1;
			   					end if;
			   when lettura1 => st <= esegui;
			   when esegui =>  if oper = "00" and conta < 1 then   -- add
				   				st <= esegui; 
			   				   else st <= idle;
				   			   end if;
			   when others => st <= idle;
			end case;
	  end if;
	  end process;
	  
	  process(st)
	  begin
		  case st is
			  when lettura0 =>
			    en_let0 <= '1';
			    en_let1 <= '0';
			    en_esegui <= '0';
			  when lettura1 =>
			    en_let0 <= '0';
			    en_let1 <= '1';
			    en_esegui <= '0';
			  when esegui =>
			    en_let0 <= '0';
			    en_let1 <= '0';
			    en_esegui <= '1';
			  when others =>
			    en_let0 <= '0';
			    en_let1 <= '0';
			    en_esegui <= '0';
			  	
			end case;  	
    end process;
	
  process(clk)
  variable conta1: integer range 0 to 16;
  begin
	  if clk'event and clk='0' then
		  if en_let0 ='1' then 
			  oper <= op;
			  d0 <= din;
			  conta <= 0;
		  end if;
		  if en_let1 = '1' then 
			  d1 <= din;
		  end if;
		  if en_esegui = '1' then
			  case oper is 
				  when "00" => -- add
				       if conta < 1 then conta <= conta +1;
				       else ris <= d0+d1;
					   end if;
				  when "01" => -- shl
				  		ris <= shl(d0,d1);
				  when "10" => -- not
				  		ris <= not d0;
				  when others => -- par
				       conta1:=0;
				       for i in 0 to 15 loop
					     if d0(i) = '1' then conta1:= conta1+1;
					     end if; 
					   end loop;	 
					   if conta1 mod 2 = 0 then
						   ris <= conv_std_logic_vector(1,16);
					   else ris <= (others => '0');
					   end if;
				end case;
			end if;	
				
	  if (en_esegui = '1' and oper/= "00") or (en_esegui = '1' and oper= "00" and conta = 1) then		  
		 ready <= '1';
	  else ready <= '0';
	  end if;
	end if;
	end process;
end beh;

				   
				                
			   